Index: palm/trunk/SOURCE/virtual_measurement_mod.f90
===================================================================
--- palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4497)
+++ palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4498)
@@ -1,20 +1,20 @@
 !> @virtual_measurement_mod.f90
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! This file is part of the PALM model system.
 !
-! PALM is free software: you can redistribute it and/or modify it under the
-! terms of the GNU General Public License as published by the Free Software
-! Foundation, either version 3 of the License, or (at your option) any later
-! version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
-!
-! Copyright 2017-2020 iz Universitaet Hannover
-!------------------------------------------------------------------------------!
+! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
+! Public License as published by the Free Software Foundation, either version 3 of the License, or
+! (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+! Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with PALM. If not, see
+! <http://www.gnu.org/licenses/>.
+!
+! Copyright 1997-2020 Leibniz Universitaet Hannover
+!--------------------------------------------------------------------------------------------------!
+!
 !
 ! Current revisions:
@@ -25,17 +25,21 @@
 ! -----------------
 ! $Id$
+! file re-formatted to follow the PALM coding standard
+!
+!
+! 4481 2020-03-31 18:55:54Z maronga
 ! bugfix: cpp-directives for serial mode added
-! 
+!
 ! 4438 2020-03-03 20:49:28Z suehring
 ! Add cpu-log points
-! 
+!
 ! 4422 2020-02-24 22:45:13Z suehring
 ! Missing trim()
-! 
+!
 ! 4408 2020-02-14 10:04:39Z gronemeier
 ! - Output of character string station_name after DOM has been enabled to
 !   output character variables
 ! - Bugfix, missing coupling_char statement when opening the input file
-! 
+!
 ! 4408 2020-02-14 10:04:39Z gronemeier
 ! write fill_value attribute
@@ -116,126 +120,124 @@
 ! Description:
 ! ------------
-!> The module acts as an interface between 'real-world' observations and
-!> model simulations. Virtual measurements will be taken in the model at the
-!> coordinates representative for the 'real-world' observation coordinates.
-!> More precisely, coordinates and measured quanties will be read from a
-!> NetCDF file which contains all required information. In the model,
-!> the same quantities (as long as all the required components are switched-on)
-!> will be sampled at the respective positions and output into an extra file,
-!> which allows for straight-forward comparison of model results with
-!> observations.
-!------------------------------------------------------------------------------!
+!> The module acts as an interface between 'real-world' observations and model simulations.
+!> Virtual measurements will be taken in the model at the coordinates representative for the
+!> 'real-world' observation coordinates. More precisely, coordinates and measured quanties will be
+!> read from a NetCDF file which contains all required information. In the model, the same
+!> quantities (as long as all the required components are switched-on) will be sampled at the
+!> respective positions and output into an extra file, which allows for straight-forward comparison
+!> of model results with observations.
+!--------------------------------------------------------------------------------------------------!
  MODULE virtual_measurement_mod
 
-    USE arrays_3d,                                                             &
-        ONLY:  dzw,                                                            &
-               exner,                                                          &
-               hyp,                                                            &
-               q,                                                              &
-               ql,                                                             &
-               pt,                                                             &
-               rho_air,                                                        &
-               u,                                                              &
-               v,                                                              &
-               w,                                                              &
-               zu,                                                             &
+    USE arrays_3d,                                                                                 &
+        ONLY:  dzw,                                                                                &
+               exner,                                                                              &
+               hyp,                                                                                &
+               q,                                                                                  &
+               ql,                                                                                 &
+               pt,                                                                                 &
+               rho_air,                                                                            &
+               u,                                                                                  &
+               v,                                                                                  &
+               w,                                                                                  &
+               zu,                                                                                 &
                zw
 
-    USE basic_constants_and_equations_mod,                                     &
-        ONLY:  convert_utm_to_geographic,                                      &
-               degc_to_k,                                                      &
-               magnus,                                                         &
-               pi,                                                             &
+    USE basic_constants_and_equations_mod,                                                         &
+        ONLY:  convert_utm_to_geographic,                                                          &
+               degc_to_k,                                                                          &
+               magnus,                                                                             &
+               pi,                                                                                 &
                rd_d_rv
 
-    USE chem_gasphase_mod,                                                     &
+    USE chem_gasphase_mod,                                                                         &
         ONLY:  nvar
 
-    USE chem_modules,                                                          &
+    USE chem_modules,                                                                              &
         ONLY:  chem_species
 
-    USE control_parameters,                                                    &
-        ONLY:  air_chemistry,                                                  &
-               coupling_char,                                                  &
-               dz,                                                             &
-               end_time,                                                       &
-               humidity,                                                       &
-               message_string,                                                 &
-               neutral,                                                        &
-               origin_date_time,                                               &
-               rho_surface,                                                    &
-               surface_pressure,                                               &
-               time_since_reference_point,                                     &
+    USE control_parameters,                                                                        &
+        ONLY:  air_chemistry,                                                                      &
+               coupling_char,                                                                      &
+               dz,                                                                                 &
+               end_time,                                                                           &
+               humidity,                                                                           &
+               message_string,                                                                     &
+               neutral,                                                                            &
+               origin_date_time,                                                                   &
+               rho_surface,                                                                        &
+               surface_pressure,                                                                   &
+               time_since_reference_point,                                                         &
                virtual_measurement
 
-    USE cpulog,                                                                &
-        ONLY:  cpu_log,                                                        &
+    USE cpulog,                                                                                    &
+        ONLY:  cpu_log,                                                                            &
                log_point_s
 
     USE data_output_module
 
-    USE grid_variables,                                                        &
-        ONLY:  ddx,                                                            &
-               ddy,                                                            &
-               dx,                                                             &
+    USE grid_variables,                                                                            &
+        ONLY:  ddx,                                                                                &
+               ddy,                                                                                &
+               dx,                                                                                 &
                dy
 
-    USE indices,                                                               &
-        ONLY:  nbgp,                                                           &
-               nzb,                                                            &
-               nzt,                                                            &
-               nxl,                                                            &
-               nxlg,                                                           &
-               nxr,                                                            &
-               nxrg,                                                           &
-               nys,                                                            &
-               nysg,                                                           &
-               nyn,                                                            &
-               nyng,                                                           &
-               topo_top_ind,                                                   &
+    USE indices,                                                                                   &
+        ONLY:  nbgp,                                                                               &
+               nzb,                                                                                &
+               nzt,                                                                                &
+               nxl,                                                                                &
+               nxlg,                                                                               &
+               nxr,                                                                                &
+               nxrg,                                                                               &
+               nys,                                                                                &
+               nysg,                                                                               &
+               nyn,                                                                                &
+               nyng,                                                                               &
+               topo_top_ind,                                                                       &
                wall_flags_total_0
 
     USE kinds
 
-    USE netcdf_data_input_mod,                                                 &
-        ONLY:  close_input_file,                                               &
-               coord_ref_sys,                                                  &
-               crs_list,                                                       &
-               get_attribute,                                                  &
-               get_dimension_length,                                           &
-               get_variable,                                                   &
-               init_model,                                                     &
-               input_file_atts,                                                &
-               input_file_vm,                                                  &
-               input_pids_static,                                              &
-               input_pids_vm,                                                  &
-               inquire_fill_value,                                             &
-               open_read_file,                                                 &
+    USE netcdf_data_input_mod,                                                                     &
+        ONLY:  close_input_file,                                                                   &
+               coord_ref_sys,                                                                      &
+               crs_list,                                                                           &
+               get_attribute,                                                                      &
+               get_dimension_length,                                                               &
+               get_variable,                                                                       &
+               init_model,                                                                         &
+               input_file_atts,                                                                    &
+               input_file_vm,                                                                      &
+               input_pids_static,                                                                  &
+               input_pids_vm,                                                                      &
+               inquire_fill_value,                                                                 &
+               open_read_file,                                                                     &
                pids_id
 
     USE pegrid
 
-    USE surface_mod,                                                           &
-        ONLY:  surf_lsm_h,                                                     &
+    USE surface_mod,                                                                               &
+        ONLY:  surf_lsm_h,                                                                         &
                surf_usm_h
 
-    USE land_surface_model_mod,                                                &
-        ONLY:  m_soil_h,                                                       &
-               nzb_soil,                                                       &
-               nzt_soil,                                                       &
-               t_soil_h,                                                       &
+    USE land_surface_model_mod,                                                                    &
+        ONLY:  m_soil_h,                                                                           &
+               nzb_soil,                                                                           &
+               nzt_soil,                                                                           &
+               t_soil_h,                                                                           &
                zs
 
-    USE radiation_model_mod,                                                   &
-        ONLY:  rad_lw_in,                                                      &
-               rad_lw_out,                                                     &
-               rad_sw_in,                                                      &
-               rad_sw_in_diff,                                                 &
-               rad_sw_out,                                                     &
+    USE radiation_model_mod,                                                                       &
+        ONLY:  rad_lw_in,                                                                          &
+               rad_lw_out,                                                                         &
+               rad_sw_in,                                                                          &
+               rad_sw_in_diff,                                                                     &
+               rad_sw_out,                                                                         &
                radiation_scheme
 
-    USE urban_surface_mod,                                                     &
-        ONLY:  nzb_wall,                                                       &
-               nzt_wall,                                                       &
+    USE urban_surface_mod,                                                                         &
+        ONLY:  nzb_wall,                                                                           &
+               nzt_wall,                                                                           &
                t_wall_h
 
@@ -244,42 +246,41 @@
 
     TYPE virt_general
-       INTEGER(iwp) ::  nvm = 0   !< number of virtual measurements
+       INTEGER(iwp) ::  nvm = 0  !< number of virtual measurements
     END TYPE virt_general
 
     TYPE virt_var_atts
-       CHARACTER(LEN=100) ::  coordinates          !< defined longname of the variable
-       CHARACTER(LEN=100) ::  grid_mapping         !< defined longname of the variable
-       CHARACTER(LEN=100) ::  long_name            !< defined longname of the variable
-       CHARACTER(LEN=100) ::  name                 !< variable name
-       CHARACTER(LEN=100) ::  standard_name        !< defined standard name of the variable
-       CHARACTER(LEN=100) ::  units                !< unit of the output variable
-
-       REAL(wp)           ::  fill_value = -9999.0 !< _FillValue attribute
+       CHARACTER(LEN=100) ::  coordinates           !< defined longname of the variable
+       CHARACTER(LEN=100) ::  grid_mapping          !< defined longname of the variable
+       CHARACTER(LEN=100) ::  long_name             !< defined longname of the variable
+       CHARACTER(LEN=100) ::  name                  !< variable name
+       CHARACTER(LEN=100) ::  standard_name         !< defined standard name of the variable
+       CHARACTER(LEN=100) ::  units                 !< unit of the output variable
+
+       REAL(wp)           ::  fill_value = -9999.0  !< _FillValue attribute
     END TYPE virt_var_atts
 
     TYPE virt_mea
-
-       CHARACTER(LEN=100)  ::  feature_type                     !< type of the real-world measurement
-       CHARACTER(LEN=100)  ::  feature_type_out = 'timeSeries'  !< type of the virtual measurement
-                                                                !< (all will be timeSeries, even trajectories)
-       CHARACTER(LEN=100)  ::  nc_filename                      !< name of the NetCDF output file for the station
-       CHARACTER(LEN=100)  ::  site                             !< name of the measurement site
-
-       CHARACTER(LEN=1000) ::  data_content = REPEAT(' ', 1000) !< string of measured variables (data output only)
-
-       INTEGER(iwp) ::  end_coord_a = 0     !< end coordinate in NetCDF file for local atmosphere observations
-       INTEGER(iwp) ::  end_coord_s = 0     !< end coordinate in NetCDF file for local soil observations
-       INTEGER(iwp) ::  file_time_index = 0 !< time index in NetCDF output file
-       INTEGER(iwp) ::  ns = 0              !< number of observation coordinates on subdomain, for atmospheric measurements
-       INTEGER(iwp) ::  ns_tot = 0          !< total number of observation coordinates, for atmospheric measurements
-       INTEGER(iwp) ::  n_tr_st             !< number of trajectories / station of a measurement
-       INTEGER(iwp) ::  nmeas               !< number of measured variables (atmosphere + soil)
-       INTEGER(iwp) ::  ns_soil = 0         !< number of observation coordinates on subdomain, for soil measurements
-       INTEGER(iwp) ::  ns_soil_tot = 0     !< total number of observation coordinates, for soil measurements
-       INTEGER(iwp) ::  start_coord_a = 0   !< start coordinate in NetCDF file for local atmosphere observations
-       INTEGER(iwp) ::  start_coord_s = 0   !< start coordinate in NetCDF file for local soil observations
-
-       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  dim_t !< number observations individual for each trajectory
-                                                         !< or station that are no _FillValues
+       CHARACTER(LEN=100)  ::  feature_type                      !< type of the real-world measurement
+       CHARACTER(LEN=100)  ::  feature_type_out = 'timeSeries'   !< type of the virtual measurement
+                                                                 !< (all will be timeSeries, even trajectories)
+       CHARACTER(LEN=100)  ::  nc_filename                       !< name of the NetCDF output file for the station
+       CHARACTER(LEN=100)  ::  site                              !< name of the measurement site
+
+       CHARACTER(LEN=1000) ::  data_content = REPEAT(' ', 1000)  !< string of measured variables (data output only)
+
+       INTEGER(iwp) ::  end_coord_a     = 0  !< end coordinate in NetCDF file for local atmosphere observations
+       INTEGER(iwp) ::  end_coord_s     = 0  !< end coordinate in NetCDF file for local soil observations
+       INTEGER(iwp) ::  file_time_index = 0  !< time index in NetCDF output file
+       INTEGER(iwp) ::  ns              = 0  !< number of observation coordinates on subdomain, for atmospheric measurements
+       INTEGER(iwp) ::  ns_tot          = 0  !< total number of observation coordinates, for atmospheric measurements
+       INTEGER(iwp) ::  n_tr_st              !< number of trajectories / station of a measurement
+       INTEGER(iwp) ::  nmeas                !< number of measured variables (atmosphere + soil)
+       INTEGER(iwp) ::  ns_soil         = 0  !< number of observation coordinates on subdomain, for soil measurements
+       INTEGER(iwp) ::  ns_soil_tot     = 0  !< total number of observation coordinates, for soil measurements
+       INTEGER(iwp) ::  start_coord_a   = 0  !< start coordinate in NetCDF file for local atmosphere observations
+       INTEGER(iwp) ::  start_coord_s   = 0  !< start coordinate in NetCDF file for local soil observations
+
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  dim_t  !< number observations individual for each trajectory
+                                                          !< or station that are no _FillValues
 
        INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  i       !< grid index for measurement position in x-direction
@@ -291,19 +292,18 @@
        INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  k_soil  !< grid index for measurement position in k-direction
 
-       LOGICAL ::  trajectory         = .FALSE. !< flag indicating that the observation is a mobile observation
-       LOGICAL ::  timseries          = .FALSE. !< flag indicating that the observation is a stationary point measurement
-       LOGICAL ::  timseries_profile  = .FALSE. !< flag indicating that the observation is a stationary profile measurement
-       LOGICAL ::  soil_sampling      = .FALSE. !< flag indicating that soil state variables were sampled
-
-       REAL(wp) ::  fill_eutm                            !< fill value for UTM coordinates in case of missing values
-       REAL(wp) ::  fill_nutm                            !< fill value for UTM coordinates in case of missing values
-       REAL(wp) ::  fill_zar                             !< fill value for heigth coordinates in case of missing values
-       REAL(wp) ::  fillout = -9999.0                    !< fill value for output in case a observation is taken
-                                                         !< e.g. from inside a building
-       REAL(wp) ::  origin_x_obs                         !< origin of the observation in UTM coordiates in x-direction
-       REAL(wp) ::  origin_y_obs                         !< origin of the observation in UTM coordiates in y-direction
-
+       LOGICAL ::  soil_sampling      = .FALSE.  !< flag indicating that soil state variables were sampled
+       LOGICAL ::  trajectory         = .FALSE.  !< flag indicating that the observation is a mobile observation
+       LOGICAL ::  timseries          = .FALSE.  !< flag indicating that the observation is a stationary point measurement
+       LOGICAL ::  timseries_profile  = .FALSE.  !< flag indicating that the observation is a stationary profile measurement
+
+       REAL(wp) ::  fill_eutm          !< fill value for UTM coordinates in case of missing values
+       REAL(wp) ::  fill_nutm          !< fill value for UTM coordinates in case of missing values
+       REAL(wp) ::  fill_zar           !< fill value for heigth coordinates in case of missing values
+       REAL(wp) ::  fillout = -9999.0  !< fill value for output in case an observation is taken e.g. from inside a building
+       REAL(wp) ::  origin_x_obs       !< origin of the observation in UTM coordiates in x-direction
+       REAL(wp) ::  origin_y_obs       !< origin of the observation in UTM coordiates in y-direction
+
+       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  depth         !< measurement depth in soil
        REAL(wp), DIMENSION(:), ALLOCATABLE   ::  zar           !< measurement height above ground level
-       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  depth         !< measurement depth in soil
 
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  measured_vars       !< measured variables
@@ -311,16 +311,12 @@
 
        TYPE( virt_var_atts ), DIMENSION(:), ALLOCATABLE ::  var_atts !< variable attributes
-
     END TYPE virt_mea
 
-    CHARACTER(LEN=5)  ::  char_eutm = "E_UTM"                      !< dimension name for UTM coordinate easting
-    CHARACTER(LEN=11) ::  char_feature = "featureType"             !< attribute name for feature type
+    CHARACTER(LEN=5)  ::  char_eutm = "E_UTM"            !< dimension name for UTM coordinate easting
+    CHARACTER(LEN=11) ::  char_feature = "featureType"   !< attribute name for feature type
 
     ! This need to be generalized
     CHARACTER(LEN=10) ::  char_fill = '_FillValue'                 !< attribute name for fill value
     CHARACTER(LEN=9)  ::  char_long = 'long_name'                  !< attribute name for long_name
-    CHARACTER(LEN=13) ::  char_standard = 'standard_name'          !< attribute name for standard_name
-    CHARACTER(LEN=5)  ::  char_unit = 'units'                      !< attribute name for standard_name
-    CHARACTER(LEN=11) ::  char_soil = "soil_sample"                !< attribute name for soil sampling indication
     CHARACTER(LEN=18) ::  char_mv = "measured_variables"           !< variable name for the array with the measured variable names
     CHARACTER(LEN=5)  ::  char_nutm = "N_UTM"                      !< dimension name for UTM coordinate northing
@@ -329,5 +325,8 @@
     CHARACTER(LEN=8)  ::  char_origy = "origin_y"                  !< attribute name for station coordinate in y
     CHARACTER(LEN=4)  ::  char_site = "site"                       !< attribute name for site name
+    CHARACTER(LEN=11) ::  char_soil = "soil_sample"                !< attribute name for soil sampling indication
+    CHARACTER(LEN=13) ::  char_standard = 'standard_name'          !< attribute name for standard_name
     CHARACTER(LEN=9)  ::  char_station_h = "station_h"             !< variable name indicating height of the site
+    CHARACTER(LEN=5)  ::  char_unit = 'units'                      !< attribute name for standard_name
     CHARACTER(LEN=1)  ::  char_zar = "z"                           !< attribute name indicating height above reference level
     CHARACTER(LEN=10) ::  type_ts   = 'timeSeries'                 !< name of stationary point measurements
